package com.gic.haoban.manage.service.service;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.service.entity.MemberUnionidRelated;
import com.github.pagehelper.PageInfo;

import java.util.List;

public interface MemberUnionRelatedService {

	MemberUnionidRelatedDTO getByWxUserIdAndUnionId(String wxEnterpriseId, String wxUserId, String unionid);
	
	MemberUnionidRelatedDTO getByMemberId(String wxUserId, String memberId);
	
	String addMemberUnionidRelated(MemberUnionidRelatedDTO dto);
	
	void delMemberUnionidRelated(MemberUnionidRelatedDTO dto);

	/**
	 * 删除外部联系人关系
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param externalUserids
	 */
	void delMemberUnionidRelatedBatch(String wxEnterpriseId, String wxUserId, List<String> externalUserids);

	List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId);

	MemberUnionidRelatedDTO getByParams(String wxUserId, String enterpriseId, String name, String createTime);

	void update(MemberUnionidRelatedDTO exsitDTO);

	void clean(String cid);

	com.github.pagehelper.Page<MemberUnionidRelated> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
			String enterpriseId);

	void cleanStaffRelated(String wxEnterpriseId, List<String> staffIds);

	/**
	 * 根据应用内的外部联系人id 获取信息
	 *
	 * @param wxUserId
	 * @param wxEnterpriseId
	 * @param selfExternalUserId
	 * @return
	 */
	MemberUnionidRelatedDTO getByWxUserIdAndSelfExternalUserId(String wxUserId, String wxEnterpriseId, String selfExternalUserId);


	/**
	 * 根据应用内的外部联系人id 获取信息
	 *
	 * @param wxEnterpriseId     wx企业标识
	 * @param selfExternalUserId 自外部的用户id
	 * @return {@link MemberUnionidRelatedDTO }
	 * @author mozhu
	 * @date 2021-12-23 22:35:47
	 */
	MemberUnionidRelatedDTO getBySelfExternalUserId(String wxEnterpriseId, String selfExternalUserId);

	/**
	 * 根据应用内的外部联系人id 获取信息
	 *
	 * @param wxUserId
	 * @param wxEnterpriseId
	 * @param selfExternalUserId
	 * @return
	 */
	List<MemberUnionidRelatedDTO> listBySelfExternalUserId(String wxUserId, String wxEnterpriseId, String selfExternalUserId);

	/**
	 * 更新用户id wx企业id
	 *
	 * @param wxEnterpriseId wx企业标识
	 * @return int
	 * @author mozhu
	 * @date 2022-06-30 16:32:21
	 */
	int updateUserIdByWxEnterpriseId(String wxEnterpriseId);

	/**
	 * 更新外部userid wx企业id
	 *
	 * @param wxEnterpriseId wx企业标识
	 * @return int
	 * @author mozhu
	 * @date 2022-06-30 19:34:27
	 */
	int updateExternalUseridByWxEnterpriseId(String wxEnterpriseId);


	/**
	 * 分页查询外部联系人id
	 *
	 * @param wxEnterpriseId wx企业标识
	 * @param basePageInfo   基本信息页
	 * @return {@link Page }<{@link MemberUnionidRelatedDTO }>
	 * @author mozhu
	 * @date 2022-06-30 17:34:06
	 */
	PageInfo<MemberUnionidRelated> listByWxEnterpriseId(String wxEnterpriseId, BasePageInfo basePageInfo);

}
